



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>hadoop配置遇到问题的解决</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">hadoop配置遇到问题的解决</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-12 04:10:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1. ssh localhost: 不能登陆：将错误提示中的文件全部删除。原因：登陆过远程主机</p>
<p>2. 问题： 伪分布式datanode启动不了：在datanode的log日志文件出现以下错误提示：</p>
<p><em><strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; ERROR org.apache.hadoop.metrics2.impl.MetricsSystemImpl: Error getting localhost name. Using 'localhost'...java.net.UnknownHostException: localhost: slave01: Name or service not known</strong></em></p>
<p>其中 在hdfs-site.xm中的配置是dfs.name.dir是/usr/local/hadoop/hdfs/name. dfs.data.dir是/usr/local/hadoop/hdfs/data</p>
<p>理解知识：</p>
<p>对于第一次使用HDFS，在启动NameNode时，需要先执行-format命令，然后才能正常启动NameNode节点的服务。</p>
<p>在NameNode节点上，有两个最重要的路径，分别被用来存储元数据信息和操作日志，而这两个路径来自于配置文件，它们对应的属性分别是dfs.name.dir和dfs.name.edits.dir，同时，它们默认的路径均是/tmp/hadoop/dfs/name</p>
<p><a href="http://blog.csdn.net/xhh198781/article/details/6904615" rel="external nofollow noreferrer">NameNode的format操作做了什么</a></p>
<div></p>
<div>执行文件系统&#26684;式化时，会在namenode数据文件夹（即配置文件中dfs.name.dir在本地系统的路径）中保存一个current/VERSION文件，记录namespaceID，标识了所&#26684;式化的namenode的版本。如果我们频繁的&#26684;式化namenode，那么datanode中保存（即配置文件中dfs.data.dir在本地系统的路径）的current/VERSION文件只是你第一次&#26684;式化时保存的namenode的ID，因此就会造成datanode与namenode之间的id不一致。导致datanode无法启动。在&quot;Master.Hadoop&quot;上使用<strong>普通</strong>用户<strong>hadoop</strong>进行操作。（<strong>备注：</strong>只需一次，下次启动不再需要&#26684;式化，只需<br />
 start-all.sh）<br /><br />
<br /><br />
解决方法：伪分布式下datanode无法启动问题 修改id &nbsp; http://blog.sina.com.cn/s/blog_76fbd24d01017qmc.html</div>
</div>
<p>3.无法解析主机kang-01，无法进行一些hadoop下的操作：在root权限下，vim hosts,增加192.168.1.103(本机地址)&nbsp;&nbsp;&nbsp; kang-01</p>
<p>4. 主要配置文件：hadoop-env.sh&nbsp;&nbsp; core-site.xml&nbsp;&nbsp; hdfs-site.xml&nbsp; mapred-site.xml&nbsp; slaves&nbsp; masters</p>
<p>5. 通过查看日志文件，来了解问题所在。</p>
<p><strong>Problem 1: 程序 'java' 已包含在下列软件包中：</strong><br /><br />
&nbsp;* default-jre<br /><br />
&nbsp;* gcj-4.6-jre-headless<br /><br />
&nbsp;* gcj-4.7-jre-headless<br /><br />
&nbsp;* openjdk-7-jre-headless<br /><br />
&nbsp;* openjdk-6-jre-headless<br /><br />
请尝试：sudo apt-get install &lt;选定的软件包&gt;</p>
<p>解决方法：(手动设置系统默认JDK)</p>
<p>在终端中依次输入命令：<strong><br /><br />
</strong></p>
<p>sudo update-alternatives --install /usr/bin/java java /home/landen/UntarFile/jdk1.7.0_17/bin/java 300</p>
<p>sudo update-alternatives --install /usr/bin/javac javac /home/landen/UntarFile/jdk1.7.0_17/bin/javac<br />
 300</p>
<p>sudo update-alternatives --config java</p>
<p>接下来输入java -version就可以看到所安装JDK的版本信息了。</p>
<p><strong>Problem 2:</strong><strong>程序 'jps' 已包含在下列软件包中：</strong></p>
<pre class="prettyprint linenums"><code>* openjdk-6-jdk<br />
* openjdk-7-jdk<br />
 Try: sudo apt-get install &lt;selected package&gt;

It is actually not a Hadoop problem. Hadoop does not use JPS.This problem is caused since you have installed JDK from Oracle (may be).<br />
You can fix this problem by using <code>update-alternatives</code> program to link <code>jps</code> to standard path directory. Use this command to fix this in a terminal<br />
</code></pre>
<pre class="prettyprint linenums"><code>Solution: sudo update-alternatives --install /usr/bin/jps jps /home/landen/UntarFile/jdk1.7.0_17/bin/jps 1<br />
Use the actual <code>jps</code> program path in the appropriate jdk (your version of jdk) instead of <code>jdk1.7</code> which is specific to me.

</code></pre>
<p>5.hadoop伪分布式下Datanode无法启动起来</p>
<p>在hadoop目录下的logs里面查看datanode 的日志文件，错误提示显示hdfs.data.dir的权限应该是rwxr-xr-x，而实际上是rwxrwxr-x</p>
<p>解决办法：先确定hdfs-site.xml里面的配置无误，然后修改hdfs.data.dir的权限</p>
<p>查看目录的相关权限可以采用命令ls -lD，或者直接用ls -la</p>
<p>权限列表</p>
<p>-rw-------&nbsp;&nbsp; (600) 只有所有者才有读和写的权限 <br /><br />
-rw-r--r--&nbsp;&nbsp; (644) 只有所有者才有读和写的权限，组群和其他人只有读的权限 <br /><br />
-rwx------&nbsp;&nbsp; (700) 只有所有者才有读，写，执行的权限 <br /><br />
-rwxr-xr-x&nbsp;&nbsp; (755) 只有所有者才有读，写，执行的权限，组群和其他人只有读和执行的权限 <br /><br />
-rwx--x--x&nbsp;&nbsp; (711) 只有所有者才有读，写，执行的权限，组群和其他人只有执行的权限 <br /><br />
-rw-rw-rw-&nbsp;&nbsp; (666) 每个人都有读写的权限 <br /><br />
-rwxrwxrwx&nbsp;&nbsp; (777) 每个人都有读写和执行的权限</p>
<p>修改权限：</p>
<p>修改权限命令</p>
<p>chmod 777 文件名</p>
<p>1.chmod 577 /home/stuser -R<br /><br />
2.umask -p 0200<br /><br />
3.chown XXXX YYYY (XXXX 为用户名 YYYY为文件名）</p>
<p>6.在虚拟机里的eclipse跑hadoop wordcount示例程序出现java heap space的错误</p>
<p>原因：</p>
<pre class="prettyprint linenums">当rs数据量大（大概800条记录以上）的时候出现javax.servlet.ServletException: Java heap space错误
<pre class="prettyprint linenums">在JVM中如果98%的时间是用于GC且可用的 Heap size 不足2%的时候将抛出此异常信息。

JVM堆的设置是指java程序运行过程中JVM可以调配使用的内存空间的设置.JVM在启动的时候会自动设置Heap size的&#20540;，其初始空间(即-Xms)是物理内存的1/64，最大空间(-Xmx)是物理内存的1/4。可以利用JVM提供的-Xmn -Xms -Xmx等选项可进行设置。<br />
例如：java -jar -Xmn16m -Xms64m -Xmx128m MyApp.jar

解决办法：<br />
如果Heap Size设置偏小，除了这些异常信息外，还会发现程序的响应速度变慢了。GC占用了更多的时间，而应用分配到的执行时间较少。<br />
Heap Size 最大不要超过可用物理内存的80%，一般的要将-Xms和-Xmx选项设置为相同，而-Xmn为1/4的-Xmx&#20540;。<br />
Heap size的 -Xms -Xmn 设置不要超出物理内存的大小。否则会提示“Error occurred during initialization of VM Could not reserve enough space for object heap”。

这个问题的根源是j<a href="http://zhidao.baidu.com/search?word=vm%E8%99%9A%E6%8B%9F%E6%9C%BA&amp;fr=qb_search_exp&amp;ie=utf8" rel="external nofollow noreferrer">vm虚拟机</a>的默认Heap大小是64M,可以通过设置其最大和最小&#20540;来实现.设置的方法主要是几个.

1.可以在windows 更改系统环境变量加上JAVA_OPTS=-Xms64m -Xmx512m

2,如果用的tomcat,在windows下,可以在C:\tomcat5.5.9\bin\catalina.bat  中加上:<br />
set JAVA_OPTS=-Xms64m -Xmx256m<br />
位置在: rem Guess CATALINA_HOME if not defined  这行的下面加合适.

3.如果是linux系统<br />
Linux  在{tomcat_home}/bin/catalina.sh的前面，加 set JAVA_OPTS='-Xms64 -Xmx512'7.
</pre>
</pre>
<p>7.Eclipse并安装Subclipse1.6x插件后,使用svn过程中报如下错误:<br /><br />
<code><br /><br />
Failed to load JavaHL Library.<br /><br />
These are the errors that were encountered:<br /><br />
no libsvnjavahl-1 in java.library.path<br /><br />
no svnjavahl-1 in java.library.path<br /><br />
/opt/local/lib/libsvnjavahl-1.0.0.0.dylib: no suitable image found. Did find: /opt/local/lib/libsvnjavahl-1.0.0.0.dylib: mach-o, but wrong architecture<br /><br />
</code><br /><br />
原来是缺少一些关联文件,去subclipse的Wiki看了看,说需要安装libsvn-java,在Ubuntu 下安装很简单,命令如下:</p>
<div>
<div>
<pre class="prettyprint linenums">sudo apt-get install libsvn-java</pre>
</div>
</div>
<p>安装完后,这文件在/usr/lib//i386-linux-gnu/jni目录下(确认一下),这个目录并不是eclipse的java.library.path路径之一,所以还需要修改eclipse.ini来告诉eclipse去哪找这个libsvn-java相关的文件.<br /><br />
打开eclipse.ini,在最后行加入如下内容(注意换行)</p>
<div>
<div>
<pre class="prettyprint linenums">-Djava.library.path=/usr/lib/jni

但是实际上我发现在eclipse的选项中将SVN改成另外的一个库就可以了。。

8.
<pre class="prettyprint linenums"><code>git clone git://git.apache.org/hadoop-common.git<br />
</code></pre>
<p>Now I get a failure on:</p>
<pre class="prettyprint linenums"><code>mvn install -DskipTests

[INFO] Apache Hadoop Main ................................ SUCCESS [6.688s]<br />
[INFO] Apache Hadoop Project POM ......................... FAILURE [1.548s]<br />
...<br />
[ERROR] Failed to execute goal org.apache.maven.plugins:maven-antrun-plugin:1.6:run (create-testdirs) on project hadoop-project: Error executing ant tasks: /usr/local/hadoop/hadoop-common/hadoop-project/target/antrun/build-main.xml (No such file or directory) -&gt; [Help 1]<br />
</code></pre>
<p>The reason being I don't have a &quot;target&quot; folder in <code>.../hadoop-project</code>. My /hadoop-project folder contains only a &quot;src&quot; folder and that's it.</p>
<p>So it appears that folder was not established. Any ideas? Here is the environment:</p>
<p></pre>
</div>
</div>
<pre class="prettyprint linenums"><code>[ERROR] Failed to execute goal org.apache.maven.plugins:maven-antrun-plugin:1.6:run (create-testdirs) on project hadoop-project: Error executing ant tasks: /home/sreejith/svn/hadoop-trunk/hadoop-project/target/antrun/build-main.xml (No such file or directory) -&gt; [Help 1]

org.apache.maven.lifecycle.LifecycleExecutionException: Failed to execute goal org.apache.maven.plugins:maven-antrun-plugin:1.6:run (create-testdirs) on project hadoop-project: Error executing ant tasks: /home/sreejith/svn/hadoop-trunk/hadoop-project/target/antrun/build-main.xml (No such file or directory)<br />
at org.apache.maven.lifecycle.internal.MojoExecutor.execute(MojoExecutor.java:217)<br />
at org.apache.maven.lifecycle.internal.MojoExecutor.execute(MojoExecutor.java:153)<br />
at org.apache.maven.lifecycle.internal.MojoExecutor.execute(MojoExecutor.java:145)<br />
at org.apache.maven.lifecycle.internal.LifecycleModuleBuilder.buildProject(LifecycleModuleBuilder.java:84)<br />
at org.apache.maven.lifecycle.internal.LifecycleModuleBuilder.buildProject(Li</code></pre>
<p>解决办法：Found a solution. Do a <code>sudo chown -R username parent-directory</code> if you haven't already. Now try,<code>mvn install -DskipTests</code>. Everything should go fine and you should get<code>BUILD SUCCESS</code>.</p>
<p>原来 sudo chown -R hadoop:hadoop /usr/local/hadoop&nbsp; 真的很重要，不设置会出现很多莫名的问题</p>
<p>(确保所有的操作都在用户hadoop下完成的)</p>
<p>8.[ERROR] Failed to execute goal org.apache.hadoop:hadoop-maven-plugins:2.2.0:protoc (compile-protoc) on project hadoop-common: org.apache.maven.plugin.MojoExecutionException: protoc version is 'libprotoc 2.4.1', expected version is '2.5.0' -&gt; [Help 1]</p>
<p>sudo apt-get remove libprotoc7 （一部分再tab）<br /><br />
再安装相应版本</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxmg7z9.html">android首次点击没反应，第二次才反应</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952gle9.html">加密&ndash;RSA前端与后台的加密&amp;amp&semi;解密</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xxv7n9.html">easyui 进度条</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y4e50q.html">LA 3516&Tab;Exploring Pyramids &lpar;记忆化搜索&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn4nld8.html">Webx学习（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm07je9.html">每天一句 linux命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjj3d8.html">elk 添加节点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljxenx9.html">Unity3d的模型自动导入帧数表</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxylm8.html">Linux 系统应用编程&mdash;&mdash;进程基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj6vy1q.html">基于promtheus的监控解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdn74d9.html">廖雪峰Java8JUnit单元测试-2使用JUnit-2异常测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4y3kk9.html">fiddler抓取https请求</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oo0418.html">PHP之ThinkPHP框架（会话）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jp6xnq.html">Spring的事务管理1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyvpnmq.html">深入浅出Java反射</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj37749.html">正睿 2019 省选附加赛 Day10</a>
		</li>
						<li><a href="https://www.batexi.com/a/95ger46q.html">CAS 单点登录4&period;24版本  登录调用其它系统并且返回客户端用其它的用户信息改造</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjxk479.html">T-SQL 无参数的存储过程的创建和执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w0vknq.html">让浏览器兼容ES6语法&lpar;gulp&plus;babel&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gp1del9.html">JAVA框架  Spring 依赖注入</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlj7rn69.html">mysql SQL语法总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpl7ovq.html">mysql插入数据时检查是否某字段已存在</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojomrpq.html">iOS-隐藏Navigationbar【导航栏无缝圆滑的隐藏】</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yk5xz8.html">3167&colon; &lbrack;Heoi2013&rsqb;Sao &lbrack;树形DP&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjx60k8.html">BZOJ 3123&colon; &lbrack;Sdoi2013&rsqb;森林 &lbrack;主席树启发式合并&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ey2d6k9.html">BZOJ 4031&colon; &lbrack;HEOI2015&rsqb;小Z的房间 &lbrack;矩阵树定理 行列式取模&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/950y61e8.html">BZOJ 2467&colon; &lbrack;中山市选2010&rsqb;生成树 &lbrack;组合计数&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zwe2e9.html">【模板小程序】循环方阵构造（仿《剑指offer》循环矩阵打印）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zwe5e9.html">Microsoft Visual Studio 中出现 Windows has triggered a breakpoint in xxx&period;exe的一个解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/950vxwm8.html">像我这样优雅地进行Spring整合MongoDB</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
